// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             (unknown)
// source: etsi/etsi14.proto

package etsi

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	ETSI14Service_GetStatus_FullMethodName     = "/danet.etsi.v1.ETSI14Service/GetStatus"
	ETSI14Service_GetKey_FullMethodName        = "/danet.etsi.v1.ETSI14Service/GetKey"
	ETSI14Service_GetKeyWithIDs_FullMethodName = "/danet.etsi.v1.ETSI14Service/GetKeyWithIDs"
)

// ETSI14ServiceClient is the client API for ETSI14Service service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ETSI14ServiceClient interface {
	// Returns Status from a KME to the calling SAE.
	// Status contains information on keys available to be requested
	// by a master SAE for a specified slave SAE.
	GetStatus(ctx context.Context, in *GetStatusRequest, opts ...grpc.CallOption) (*GetStatusResponse, error)
	// Returns Key container data from the KME to the calling master SAE.
	// Key container data contains one or more keys. The calling master SAE may supply
	// Key request data to specify the requirement on Key container data. The slave SAE
	// specified by the slave_SAE_ID parameter may subsequently request matching keys
	// from a remote KME using key_ID identifiers from the returned Key container.
	GetKey(ctx context.Context, in *GetKeyRequest, opts ...grpc.CallOption) (*GetKeyResponse, error)
	// Returns Key container from the KME to the calling slave SAE.
	// Key container contains keys matching those previously delivered to a remote master SAE
	// based on the Key IDs supplied from the remote master SAE in response to its call to Get key.
	// The KME shall reject the request with a 401 HTTP status code if the SAE ID of the requestor
	// was not an SAE ID supplied to the "Get key" method each time it was called resulting in the
	// return of any of the Key IDs being requested.
	GetKeyWithIDs(ctx context.Context, in *GetKeyWithIDsRequest, opts ...grpc.CallOption) (*GetKeyWithIDsResponse, error)
}

type eTSI14ServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewETSI14ServiceClient(cc grpc.ClientConnInterface) ETSI14ServiceClient {
	return &eTSI14ServiceClient{cc}
}

func (c *eTSI14ServiceClient) GetStatus(ctx context.Context, in *GetStatusRequest, opts ...grpc.CallOption) (*GetStatusResponse, error) {
	out := new(GetStatusResponse)
	err := c.cc.Invoke(ctx, ETSI14Service_GetStatus_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *eTSI14ServiceClient) GetKey(ctx context.Context, in *GetKeyRequest, opts ...grpc.CallOption) (*GetKeyResponse, error) {
	out := new(GetKeyResponse)
	err := c.cc.Invoke(ctx, ETSI14Service_GetKey_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *eTSI14ServiceClient) GetKeyWithIDs(ctx context.Context, in *GetKeyWithIDsRequest, opts ...grpc.CallOption) (*GetKeyWithIDsResponse, error) {
	out := new(GetKeyWithIDsResponse)
	err := c.cc.Invoke(ctx, ETSI14Service_GetKeyWithIDs_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ETSI14ServiceServer is the server API for ETSI14Service service.
// All implementations must embed UnimplementedETSI14ServiceServer
// for forward compatibility
type ETSI14ServiceServer interface {
	// Returns Status from a KME to the calling SAE.
	// Status contains information on keys available to be requested
	// by a master SAE for a specified slave SAE.
	GetStatus(context.Context, *GetStatusRequest) (*GetStatusResponse, error)
	// Returns Key container data from the KME to the calling master SAE.
	// Key container data contains one or more keys. The calling master SAE may supply
	// Key request data to specify the requirement on Key container data. The slave SAE
	// specified by the slave_SAE_ID parameter may subsequently request matching keys
	// from a remote KME using key_ID identifiers from the returned Key container.
	GetKey(context.Context, *GetKeyRequest) (*GetKeyResponse, error)
	// Returns Key container from the KME to the calling slave SAE.
	// Key container contains keys matching those previously delivered to a remote master SAE
	// based on the Key IDs supplied from the remote master SAE in response to its call to Get key.
	// The KME shall reject the request with a 401 HTTP status code if the SAE ID of the requestor
	// was not an SAE ID supplied to the "Get key" method each time it was called resulting in the
	// return of any of the Key IDs being requested.
	GetKeyWithIDs(context.Context, *GetKeyWithIDsRequest) (*GetKeyWithIDsResponse, error)
	mustEmbedUnimplementedETSI14ServiceServer()
}

// UnimplementedETSI14ServiceServer must be embedded to have forward compatible implementations.
type UnimplementedETSI14ServiceServer struct {
}

func (UnimplementedETSI14ServiceServer) GetStatus(context.Context, *GetStatusRequest) (*GetStatusResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetStatus not implemented")
}
func (UnimplementedETSI14ServiceServer) GetKey(context.Context, *GetKeyRequest) (*GetKeyResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetKey not implemented")
}
func (UnimplementedETSI14ServiceServer) GetKeyWithIDs(context.Context, *GetKeyWithIDsRequest) (*GetKeyWithIDsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetKeyWithIDs not implemented")
}
func (UnimplementedETSI14ServiceServer) mustEmbedUnimplementedETSI14ServiceServer() {}

// UnsafeETSI14ServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ETSI14ServiceServer will
// result in compilation errors.
type UnsafeETSI14ServiceServer interface {
	mustEmbedUnimplementedETSI14ServiceServer()
}

func RegisterETSI14ServiceServer(s grpc.ServiceRegistrar, srv ETSI14ServiceServer) {
	s.RegisterService(&ETSI14Service_ServiceDesc, srv)
}

func _ETSI14Service_GetStatus_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetStatusRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ETSI14ServiceServer).GetStatus(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ETSI14Service_GetStatus_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ETSI14ServiceServer).GetStatus(ctx, req.(*GetStatusRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ETSI14Service_GetKey_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetKeyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ETSI14ServiceServer).GetKey(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ETSI14Service_GetKey_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ETSI14ServiceServer).GetKey(ctx, req.(*GetKeyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ETSI14Service_GetKeyWithIDs_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetKeyWithIDsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ETSI14ServiceServer).GetKeyWithIDs(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ETSI14Service_GetKeyWithIDs_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ETSI14ServiceServer).GetKeyWithIDs(ctx, req.(*GetKeyWithIDsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ETSI14Service_ServiceDesc is the grpc.ServiceDesc for ETSI14Service service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ETSI14Service_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "danet.etsi.v1.ETSI14Service",
	HandlerType: (*ETSI14ServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetStatus",
			Handler:    _ETSI14Service_GetStatus_Handler,
		},
		{
			MethodName: "GetKey",
			Handler:    _ETSI14Service_GetKey_Handler,
		},
		{
			MethodName: "GetKeyWithIDs",
			Handler:    _ETSI14Service_GetKeyWithIDs_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "etsi/etsi14.proto",
}
