/*
ETSI14REST

OpenAPI definition of ETSI GS QKD 014 Standard.

API version: 0.0.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package etsi14

import (
	"encoding/json"
)

// checks if the ErrorFormat type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ErrorFormat{}

// ErrorFormat struct for ErrorFormat
type ErrorFormat struct {
	Message *string `json:"message,omitempty"`
	Details []map[string]string `json:"details,omitempty"`
}

// NewErrorFormat instantiates a new ErrorFormat object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewErrorFormat() *ErrorFormat {
	this := ErrorFormat{}
	return &this
}

// NewErrorFormatWithDefaults instantiates a new ErrorFormat object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewErrorFormatWithDefaults() *ErrorFormat {
	this := ErrorFormat{}
	return &this
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *ErrorFormat) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ErrorFormat) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *ErrorFormat) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *ErrorFormat) SetMessage(v string) {
	o.Message = &v
}

// GetDetails returns the Details field value if set, zero value otherwise.
func (o *ErrorFormat) GetDetails() []map[string]string {
	if o == nil || IsNil(o.Details) {
		var ret []map[string]string
		return ret
	}
	return o.Details
}

// GetDetailsOk returns a tuple with the Details field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ErrorFormat) GetDetailsOk() ([]map[string]string, bool) {
	if o == nil || IsNil(o.Details) {
		return nil, false
	}
	return o.Details, true
}

// HasDetails returns a boolean if a field has been set.
func (o *ErrorFormat) HasDetails() bool {
	if o != nil && !IsNil(o.Details) {
		return true
	}

	return false
}

// SetDetails gets a reference to the given []map[string]string and assigns it to the Details field.
func (o *ErrorFormat) SetDetails(v []map[string]string) {
	o.Details = v
}

func (o ErrorFormat) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ErrorFormat) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if !IsNil(o.Details) {
		toSerialize["details"] = o.Details
	}
	return toSerialize, nil
}

type NullableErrorFormat struct {
	value *ErrorFormat
	isSet bool
}

func (v NullableErrorFormat) Get() *ErrorFormat {
	return v.value
}

func (v *NullableErrorFormat) Set(val *ErrorFormat) {
	v.value = val
	v.isSet = true
}

func (v NullableErrorFormat) IsSet() bool {
	return v.isSet
}

func (v *NullableErrorFormat) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableErrorFormat(val *ErrorFormat) *NullableErrorFormat {
	return &NullableErrorFormat{value: val, isSet: true}
}

func (v NullableErrorFormat) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableErrorFormat) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


