/*
ETSI14REST

OpenAPI definition of ETSI GS QKD 014 Standard.

API version: 0.0.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package etsi14

import (
	"encoding/json"
)

// checks if the Status type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Status{}

// Status struct for Status
type Status struct {
	SourceKMEID *string `json:"source_KME_ID,omitempty"`
	TargetKMEID *string `json:"target_KME_ID,omitempty"`
	MasterSAEID *string `json:"master_SAE_ID,omitempty"`
	SlaveSAEID *string `json:"slave_SAE_ID,omitempty"`
	KeySize *int64 `json:"key_size,omitempty"`
	StoredKeyCount *int64 `json:"stored_key_count,omitempty"`
	MaxKeyCount *int64 `json:"max_key_count,omitempty"`
	MaxKeyPerRequest *int64 `json:"max_key_per_request,omitempty"`
	MaxKeySize *int64 `json:"max_key_size,omitempty"`
	MinKeySize *int64 `json:"min_key_size,omitempty"`
	MaxSAEIDCount *int64 `json:"max_SAE_ID_count,omitempty"`
}

// NewStatus instantiates a new Status object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewStatus() *Status {
	this := Status{}
	return &this
}

// NewStatusWithDefaults instantiates a new Status object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewStatusWithDefaults() *Status {
	this := Status{}
	return &this
}

// GetSourceKMEID returns the SourceKMEID field value if set, zero value otherwise.
func (o *Status) GetSourceKMEID() string {
	if o == nil || IsNil(o.SourceKMEID) {
		var ret string
		return ret
	}
	return *o.SourceKMEID
}

// GetSourceKMEIDOk returns a tuple with the SourceKMEID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetSourceKMEIDOk() (*string, bool) {
	if o == nil || IsNil(o.SourceKMEID) {
		return nil, false
	}
	return o.SourceKMEID, true
}

// HasSourceKMEID returns a boolean if a field has been set.
func (o *Status) HasSourceKMEID() bool {
	if o != nil && !IsNil(o.SourceKMEID) {
		return true
	}

	return false
}

// SetSourceKMEID gets a reference to the given string and assigns it to the SourceKMEID field.
func (o *Status) SetSourceKMEID(v string) {
	o.SourceKMEID = &v
}

// GetTargetKMEID returns the TargetKMEID field value if set, zero value otherwise.
func (o *Status) GetTargetKMEID() string {
	if o == nil || IsNil(o.TargetKMEID) {
		var ret string
		return ret
	}
	return *o.TargetKMEID
}

// GetTargetKMEIDOk returns a tuple with the TargetKMEID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetTargetKMEIDOk() (*string, bool) {
	if o == nil || IsNil(o.TargetKMEID) {
		return nil, false
	}
	return o.TargetKMEID, true
}

// HasTargetKMEID returns a boolean if a field has been set.
func (o *Status) HasTargetKMEID() bool {
	if o != nil && !IsNil(o.TargetKMEID) {
		return true
	}

	return false
}

// SetTargetKMEID gets a reference to the given string and assigns it to the TargetKMEID field.
func (o *Status) SetTargetKMEID(v string) {
	o.TargetKMEID = &v
}

// GetMasterSAEID returns the MasterSAEID field value if set, zero value otherwise.
func (o *Status) GetMasterSAEID() string {
	if o == nil || IsNil(o.MasterSAEID) {
		var ret string
		return ret
	}
	return *o.MasterSAEID
}

// GetMasterSAEIDOk returns a tuple with the MasterSAEID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetMasterSAEIDOk() (*string, bool) {
	if o == nil || IsNil(o.MasterSAEID) {
		return nil, false
	}
	return o.MasterSAEID, true
}

// HasMasterSAEID returns a boolean if a field has been set.
func (o *Status) HasMasterSAEID() bool {
	if o != nil && !IsNil(o.MasterSAEID) {
		return true
	}

	return false
}

// SetMasterSAEID gets a reference to the given string and assigns it to the MasterSAEID field.
func (o *Status) SetMasterSAEID(v string) {
	o.MasterSAEID = &v
}

// GetSlaveSAEID returns the SlaveSAEID field value if set, zero value otherwise.
func (o *Status) GetSlaveSAEID() string {
	if o == nil || IsNil(o.SlaveSAEID) {
		var ret string
		return ret
	}
	return *o.SlaveSAEID
}

// GetSlaveSAEIDOk returns a tuple with the SlaveSAEID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetSlaveSAEIDOk() (*string, bool) {
	if o == nil || IsNil(o.SlaveSAEID) {
		return nil, false
	}
	return o.SlaveSAEID, true
}

// HasSlaveSAEID returns a boolean if a field has been set.
func (o *Status) HasSlaveSAEID() bool {
	if o != nil && !IsNil(o.SlaveSAEID) {
		return true
	}

	return false
}

// SetSlaveSAEID gets a reference to the given string and assigns it to the SlaveSAEID field.
func (o *Status) SetSlaveSAEID(v string) {
	o.SlaveSAEID = &v
}

// GetKeySize returns the KeySize field value if set, zero value otherwise.
func (o *Status) GetKeySize() int64 {
	if o == nil || IsNil(o.KeySize) {
		var ret int64
		return ret
	}
	return *o.KeySize
}

// GetKeySizeOk returns a tuple with the KeySize field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetKeySizeOk() (*int64, bool) {
	if o == nil || IsNil(o.KeySize) {
		return nil, false
	}
	return o.KeySize, true
}

// HasKeySize returns a boolean if a field has been set.
func (o *Status) HasKeySize() bool {
	if o != nil && !IsNil(o.KeySize) {
		return true
	}

	return false
}

// SetKeySize gets a reference to the given int64 and assigns it to the KeySize field.
func (o *Status) SetKeySize(v int64) {
	o.KeySize = &v
}

// GetStoredKeyCount returns the StoredKeyCount field value if set, zero value otherwise.
func (o *Status) GetStoredKeyCount() int64 {
	if o == nil || IsNil(o.StoredKeyCount) {
		var ret int64
		return ret
	}
	return *o.StoredKeyCount
}

// GetStoredKeyCountOk returns a tuple with the StoredKeyCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetStoredKeyCountOk() (*int64, bool) {
	if o == nil || IsNil(o.StoredKeyCount) {
		return nil, false
	}
	return o.StoredKeyCount, true
}

// HasStoredKeyCount returns a boolean if a field has been set.
func (o *Status) HasStoredKeyCount() bool {
	if o != nil && !IsNil(o.StoredKeyCount) {
		return true
	}

	return false
}

// SetStoredKeyCount gets a reference to the given int64 and assigns it to the StoredKeyCount field.
func (o *Status) SetStoredKeyCount(v int64) {
	o.StoredKeyCount = &v
}

// GetMaxKeyCount returns the MaxKeyCount field value if set, zero value otherwise.
func (o *Status) GetMaxKeyCount() int64 {
	if o == nil || IsNil(o.MaxKeyCount) {
		var ret int64
		return ret
	}
	return *o.MaxKeyCount
}

// GetMaxKeyCountOk returns a tuple with the MaxKeyCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetMaxKeyCountOk() (*int64, bool) {
	if o == nil || IsNil(o.MaxKeyCount) {
		return nil, false
	}
	return o.MaxKeyCount, true
}

// HasMaxKeyCount returns a boolean if a field has been set.
func (o *Status) HasMaxKeyCount() bool {
	if o != nil && !IsNil(o.MaxKeyCount) {
		return true
	}

	return false
}

// SetMaxKeyCount gets a reference to the given int64 and assigns it to the MaxKeyCount field.
func (o *Status) SetMaxKeyCount(v int64) {
	o.MaxKeyCount = &v
}

// GetMaxKeyPerRequest returns the MaxKeyPerRequest field value if set, zero value otherwise.
func (o *Status) GetMaxKeyPerRequest() int64 {
	if o == nil || IsNil(o.MaxKeyPerRequest) {
		var ret int64
		return ret
	}
	return *o.MaxKeyPerRequest
}

// GetMaxKeyPerRequestOk returns a tuple with the MaxKeyPerRequest field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetMaxKeyPerRequestOk() (*int64, bool) {
	if o == nil || IsNil(o.MaxKeyPerRequest) {
		return nil, false
	}
	return o.MaxKeyPerRequest, true
}

// HasMaxKeyPerRequest returns a boolean if a field has been set.
func (o *Status) HasMaxKeyPerRequest() bool {
	if o != nil && !IsNil(o.MaxKeyPerRequest) {
		return true
	}

	return false
}

// SetMaxKeyPerRequest gets a reference to the given int64 and assigns it to the MaxKeyPerRequest field.
func (o *Status) SetMaxKeyPerRequest(v int64) {
	o.MaxKeyPerRequest = &v
}

// GetMaxKeySize returns the MaxKeySize field value if set, zero value otherwise.
func (o *Status) GetMaxKeySize() int64 {
	if o == nil || IsNil(o.MaxKeySize) {
		var ret int64
		return ret
	}
	return *o.MaxKeySize
}

// GetMaxKeySizeOk returns a tuple with the MaxKeySize field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetMaxKeySizeOk() (*int64, bool) {
	if o == nil || IsNil(o.MaxKeySize) {
		return nil, false
	}
	return o.MaxKeySize, true
}

// HasMaxKeySize returns a boolean if a field has been set.
func (o *Status) HasMaxKeySize() bool {
	if o != nil && !IsNil(o.MaxKeySize) {
		return true
	}

	return false
}

// SetMaxKeySize gets a reference to the given int64 and assigns it to the MaxKeySize field.
func (o *Status) SetMaxKeySize(v int64) {
	o.MaxKeySize = &v
}

// GetMinKeySize returns the MinKeySize field value if set, zero value otherwise.
func (o *Status) GetMinKeySize() int64 {
	if o == nil || IsNil(o.MinKeySize) {
		var ret int64
		return ret
	}
	return *o.MinKeySize
}

// GetMinKeySizeOk returns a tuple with the MinKeySize field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetMinKeySizeOk() (*int64, bool) {
	if o == nil || IsNil(o.MinKeySize) {
		return nil, false
	}
	return o.MinKeySize, true
}

// HasMinKeySize returns a boolean if a field has been set.
func (o *Status) HasMinKeySize() bool {
	if o != nil && !IsNil(o.MinKeySize) {
		return true
	}

	return false
}

// SetMinKeySize gets a reference to the given int64 and assigns it to the MinKeySize field.
func (o *Status) SetMinKeySize(v int64) {
	o.MinKeySize = &v
}

// GetMaxSAEIDCount returns the MaxSAEIDCount field value if set, zero value otherwise.
func (o *Status) GetMaxSAEIDCount() int64 {
	if o == nil || IsNil(o.MaxSAEIDCount) {
		var ret int64
		return ret
	}
	return *o.MaxSAEIDCount
}

// GetMaxSAEIDCountOk returns a tuple with the MaxSAEIDCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Status) GetMaxSAEIDCountOk() (*int64, bool) {
	if o == nil || IsNil(o.MaxSAEIDCount) {
		return nil, false
	}
	return o.MaxSAEIDCount, true
}

// HasMaxSAEIDCount returns a boolean if a field has been set.
func (o *Status) HasMaxSAEIDCount() bool {
	if o != nil && !IsNil(o.MaxSAEIDCount) {
		return true
	}

	return false
}

// SetMaxSAEIDCount gets a reference to the given int64 and assigns it to the MaxSAEIDCount field.
func (o *Status) SetMaxSAEIDCount(v int64) {
	o.MaxSAEIDCount = &v
}

func (o Status) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Status) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.SourceKMEID) {
		toSerialize["source_KME_ID"] = o.SourceKMEID
	}
	if !IsNil(o.TargetKMEID) {
		toSerialize["target_KME_ID"] = o.TargetKMEID
	}
	if !IsNil(o.MasterSAEID) {
		toSerialize["master_SAE_ID"] = o.MasterSAEID
	}
	if !IsNil(o.SlaveSAEID) {
		toSerialize["slave_SAE_ID"] = o.SlaveSAEID
	}
	if !IsNil(o.KeySize) {
		toSerialize["key_size"] = o.KeySize
	}
	if !IsNil(o.StoredKeyCount) {
		toSerialize["stored_key_count"] = o.StoredKeyCount
	}
	if !IsNil(o.MaxKeyCount) {
		toSerialize["max_key_count"] = o.MaxKeyCount
	}
	if !IsNil(o.MaxKeyPerRequest) {
		toSerialize["max_key_per_request"] = o.MaxKeyPerRequest
	}
	if !IsNil(o.MaxKeySize) {
		toSerialize["max_key_size"] = o.MaxKeySize
	}
	if !IsNil(o.MinKeySize) {
		toSerialize["min_key_size"] = o.MinKeySize
	}
	if !IsNil(o.MaxSAEIDCount) {
		toSerialize["max_SAE_ID_count"] = o.MaxSAEIDCount
	}
	return toSerialize, nil
}

type NullableStatus struct {
	value *Status
	isSet bool
}

func (v NullableStatus) Get() *Status {
	return v.value
}

func (v *NullableStatus) Set(val *Status) {
	v.value = val
	v.isSet = true
}

func (v NullableStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStatus(val *Status) *NullableStatus {
	return &NullableStatus{value: val, isSet: true}
}

func (v NullableStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


