package crypto

import (
	"encoding/base64"
	"testing"

	"github.com/google/uuid"
	"github.com/stretchr/testify/assert"
)

func TestCrypto_Random256BitKey(t *testing.T) {
	key, err := Random256BitKey()
	assert.NoError(t, err)

	// check key id is not nil
	assert.NotEqual(t, uuid.Nil, key.ID)

	// check for correct key length
	assert.Len(t, key.Key, 32)
	assert.NotEqual(t, make([]byte, 32), key.Key)

	// decode base64 encoded string
	keyFromBase64, err := base64.StdEncoding.DecodeString(key.KeyAsBase64)
	assert.NoError(t, err)

	// check for correct key length
	assert.Len(t, keyFromBase64, 32)
	// check if both keys represent the same value
	assert.Equal(t, key.Key, keyFromBase64)
}
