#!/bin/sh

## Note: This script does not clean up network elements already existing in the storage. Running it repeatedly will
## create a garbage storage.

GOSDNC_PATH="../../../artifacts/gosdnc"
CONTROLLER_ADDRESS=$1
ADMINPW="TestPassword"
KMS_PLUGIN="e404ecf7-4860-41ee-9cee-3dd6af6c5e2b"
PND_UUID="5f20f34b-cbd0-4511-9ddc-c50cf6a3b49d"

cd ../../config/gosdnc

echo 'Logging in via gosdnc and setting up KMS in controller...'
echo "CONTROLLER_ADDRESS: $CONTROLLER_ADDRESS"

echo 'Current folder path:'
pwd

# TODO: Add --tls when adding certs to this!

## Call login and create entries for all the network elements.
$GOSDNC_PATH login --controller $CONTROLLER_ADDRESS --u admin --p $ADMINPW
$GOSDNC_PATH pnd use $PND_UUID

$GOSDNC_PATH mne create --address "kms01:7030" --name kms_1 --password admin --plugin-id $KMS_PLUGIN --username admin --uuid 0ff33c82-7fe1-482b-a0ca-67565806ee4b
$GOSDNC_PATH mne create --address "kms02:7030" --name kms_2 --password admin --plugin-id $KMS_PLUGIN --username admin --uuid 5e41c291-6121-4335-84f6-41e04b8bdaa2
