package utils

import (
	"fmt"
	"math/rand"

	"github.com/sirupsen/logrus"
)

func GetRandomDataForGivenLength(rng *rand.Rand, numberOfBytes int) ([]byte, error) {
	if numberOfBytes <= 0 {
		logrus.Errorf("Number of bytes must be greater than 0")
		return nil, fmt.Errorf("number of bytes must be greater than 0, is %d", numberOfBytes)
	}

	b := make([]byte, numberOfBytes)
	_, err := rng.Read(b)
	if err != nil {
		logrus.Errorf("Error generating random bytes: %s", err)
		return nil, err
	}
	logrus.Debugf("Generated %d random bytes", len(b))

	return b, nil
}
