package utils

import (
	"math/rand"
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestUtils_GenerateRandomDataForGivenLength(t *testing.T) {
	lengths := []int{1, 123, 8000, 10000, 10000000}
	values := [][]byte{}

	randomGenerator := rand.New(rand.NewSource(12345))
	for _, length := range lengths {
		bytes, err := GetRandomDataForGivenLength(randomGenerator, length)
		assert.NoError(t, err)
		assert.Equal(t, length, len(bytes))
		for _, value := range values {
			assert.NotEqual(t, bytes, value)
		}
		values = append(values, bytes)
	}
}

func TestUtils_GenerateRandomDataForGivenLengthNegative(t *testing.T) {
	randomGenerator := rand.New(rand.NewSource(12345))
	_, err := GetRandomDataForGivenLength(randomGenerator, -1)
	assert.Error(t, err)
}
